Attribute VB_Name = "WinInetAPI"
Option Explicit '// Good for catching those typos... always use them:)
'/////////////////////////////////////////////////////////
'//               WinInet API Example                   //
'/////////////////////////////////////////////////////////
'// This source code is available for you to learn from //
'// and to use them in your projects.                   //
'//                                                     //
'// Please mention WebSoftware in the credits as a way  //
'// of saying thank-you:)                               //
'/////////////////////////////////////////////////////////
'//            http://www.wSoftware.net                 //
'/////////////////////////////////////////////////////////

'// Some winInet API functions
Private Declare Function InternetOpen Lib "wininet.dll" Alias "InternetOpenA" (ByVal sAgent As String, ByVal lAccessType As Long, ByVal sProxyName As String, ByVal sProxyBypass As String, ByVal lFlags As Long) As Long
Private Declare Function InternetAttemptConnect Lib "WinInet" (ByVal dwReserved As Long) As Long
Private Declare Function InternetGetConnectedStateEx Lib "wininet.dll" Alias "InternetGetConnectedStateExA" (lpdwFlags As Long, lpszConnectionName As Long, dwNameLen As Long, ByVal dwReserved As Long) As Long
Private Declare Function InternetAutodialHangup Lib "wininet.dll" (ByVal dwReserved_ As Long) As Long
'// Constants required
Const scUserAgent = "WinInet Example"
Const INTERNET_OPEN_TYPE_PRECONFIG = 0

Public Function ConnectToISP() As Boolean
'// Type: Function
'// Returns: TRUE if connection attemp successful and FALSE if not
    If InternetAttemptConnect(0) <> 0 Then Exit Function
    If InternetOpen(scUserAgent, INTERNET_OPEN_TYPE_PRECONFIG, vbNullString, vbNullString, 0) = 0 Then ConnectToISP = False Else ConnectToISP = True

End Function

Public Function HangUpModem() As Boolean
'// Type: Function
'// Returns: TRUE if sucessful and FALSE if fails
    If InternetAutodialHangup(0&) = 0 Then HangUpModem = False Else HangUpModem = True

End Function

Public Function IsConnected() As Boolean
'// Type: Function
'// Returns: TRUE if connected and FALSE if not
  Dim lNameLen            As Long
  Dim lRetVal             As Long
  Dim lConnectionFlags    As Long
  Dim LPTR                As Long
  Dim lNameLenPtr         As Long
  Dim sConnectionName     As String
    
    sConnectionName = Space$(256)
    lNameLen = 256
    LPTR = StrPtr(sConnectionName)
    lNameLenPtr = VarPtr(lNameLen)

    lRetVal = InternetGetConnectedStateEx(lConnectionFlags, ByVal LPTR, ByVal lNameLen, 0&)

    IsConnected = (lRetVal <> 0)

End Function
